(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@editorjs/code'), require('@editorjs/embed'), require('@editorjs/header'), require('@editorjs/image'), require('@editorjs/inline-code'), require('@editorjs/link'), require('@editorjs/list'), require('@editorjs/paragraph'), require('@editorjs/quote'), require('@editorjs/simple-image'), require('@editorjs/warning')) :
    typeof define === 'function' && define.amd ? define('@tinynodes/ngx-editorjs-plugins', ['exports', '@angular/common', '@angular/core', '@editorjs/code', '@editorjs/embed', '@editorjs/header', '@editorjs/image', '@editorjs/inline-code', '@editorjs/link', '@editorjs/list', '@editorjs/paragraph', '@editorjs/quote', '@editorjs/simple-image', '@editorjs/warning'], factory) :
    (global = global || self, factory((global.tinynodes = global.tinynodes || {}, global.tinynodes['ngx-editorjs-plugins'] = {}), global.ng.common, global.ng.core, global.Code, global.Embed, global.Header, global.Image, global.InlineCode, global.Link, global.List, global.Marker, global.Quote, global.SimpleImage, global.Warning));
}(this, (function (exports, common, core, Code, Embed, Header, Image, InlineCode, Link, List, Marker, Quote, SimpleImage, Warning) { 'use strict';

    Code = Code && Object.prototype.hasOwnProperty.call(Code, 'default') ? Code['default'] : Code;
    Embed = Embed && Object.prototype.hasOwnProperty.call(Embed, 'default') ? Embed['default'] : Embed;
    Header = Header && Object.prototype.hasOwnProperty.call(Header, 'default') ? Header['default'] : Header;
    Image = Image && Object.prototype.hasOwnProperty.call(Image, 'default') ? Image['default'] : Image;
    InlineCode = InlineCode && Object.prototype.hasOwnProperty.call(InlineCode, 'default') ? InlineCode['default'] : InlineCode;
    Link = Link && Object.prototype.hasOwnProperty.call(Link, 'default') ? Link['default'] : Link;
    List = List && Object.prototype.hasOwnProperty.call(List, 'default') ? List['default'] : List;
    Marker = Marker && Object.prototype.hasOwnProperty.call(Marker, 'default') ? Marker['default'] : Marker;
    Quote = Quote && Object.prototype.hasOwnProperty.call(Quote, 'default') ? Quote['default'] : Quote;
    SimpleImage = SimpleImage && Object.prototype.hasOwnProperty.call(SimpleImage, 'default') ? SimpleImage['default'] : SimpleImage;
    Warning = Warning && Object.prototype.hasOwnProperty.call(Warning, 'default') ? Warning['default'] : Warning;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * The types of plugins supported, currently block and inline
     */

    (function (PluginTypes) {
        /**
         * A EditorJS block plugin
         */
        PluginTypes["Block"] = "block";
        /**
         * A EditorJS inline plugin
         */
        PluginTypes["Inline"] = "inline";
    })(exports.PluginTypes || (exports.PluginTypes = {}));
    /**
     * The Injection token for initial plugins as defined in the ngx-editorjs module
     */
    var EDITOR_JS_TOOL_INJECTOR = new core.InjectionToken('EDITOR_JS_TOOL_INJECTOR');
    /**
     * Injection token for a plugin config
     */
    var PLUGIN_CONFIG = new core.InjectionToken('PLUGIN_CONFIG');
    /**
     * Injection token for the plugin config map
     */
    var PluginClasses = new core.InjectionToken('PluginClasses');

    var ɵ0 = Code, ɵ1 = {
        key: 'code',
        type: exports.PluginTypes.Block,
        pluginName: 'EditorJS Code'
    };
    /**
     * A module that provides the default EditorJS `<code>` block tool.
     * See [the GitHub repo](https://github.com/editor-js/code) for API details
     */
    var PluginCodeModule = /** @class */ (function () {
        function PluginCodeModule() {
        }
        PluginCodeModule = __decorate([
            core.NgModule({
                providers: [
                    {
                        provide: EDITOR_JS_TOOL_INJECTOR,
                        useValue: ɵ0,
                        multi: true
                    },
                    {
                        provide: PLUGIN_CONFIG,
                        useValue: ɵ1,
                        multi: true
                    }
                ]
            })
        ], PluginCodeModule);
        return PluginCodeModule;
    }());

    var ɵ0$1 = Embed, ɵ1$1 = {
        key: 'embed',
        type: exports.PluginTypes.Block,
        pluginName: 'EditorJS Embed Block',
        inlineToolbar: true
    };
    /**
     * A module that provides the default EditorJS `<p>` block tool.
     * See [the GitHub repo](https://github.com/editor-js/paragraph) for API details
     */
    var PluginEmbedModule = /** @class */ (function () {
        function PluginEmbedModule() {
        }
        PluginEmbedModule = __decorate([
            core.NgModule({
                providers: [
                    {
                        provide: EDITOR_JS_TOOL_INJECTOR,
                        useValue: ɵ0$1,
                        multi: true
                    },
                    {
                        provide: PLUGIN_CONFIG,
                        useValue: ɵ1$1,
                        multi: true
                    }
                ]
            })
        ], PluginEmbedModule);
        return PluginEmbedModule;
    }());

    var ɵ0$2 = Header, ɵ1$2 = {
        key: 'header',
        type: exports.PluginTypes.Block,
        pluginName: 'EditorJS Header'
    };
    /**
     * A module that provides the default EditorJS header block tool.
     * See [the GitHub repo](https://github.com/editor-js/header) for API details
     */
    var PluginHeaderModule = /** @class */ (function () {
        function PluginHeaderModule() {
        }
        PluginHeaderModule = __decorate([
            core.NgModule({
                providers: [
                    {
                        provide: EDITOR_JS_TOOL_INJECTOR,
                        useValue: ɵ0$2,
                        multi: true
                    },
                    {
                        provide: PLUGIN_CONFIG,
                        useValue: ɵ1$2,
                        multi: true
                    }
                ]
            })
        ], PluginHeaderModule);
        return PluginHeaderModule;
    }());

    var ɵ0$3 = Image, ɵ1$3 = {
        key: 'image',
        type: exports.PluginTypes.Block,
        pluginName: 'EditorJS Image'
    };
    /**
     * A module that provides the default EditorJS `<img>` block tool.
     * See [the GitHub repo](https://github.com/editor-js/image) for API details
     */
    var PluginImageModule = /** @class */ (function () {
        function PluginImageModule() {
        }
        PluginImageModule = __decorate([
            core.NgModule({
                providers: [
                    {
                        provide: EDITOR_JS_TOOL_INJECTOR,
                        useValue: ɵ0$3,
                        multi: true
                    },
                    {
                        provide: PLUGIN_CONFIG,
                        useValue: ɵ1$3,
                        multi: true
                    }
                ]
            })
        ], PluginImageModule);
        return PluginImageModule;
    }());

    var ɵ0$4 = InlineCode, ɵ1$4 = {
        key: 'inline-code',
        type: exports.PluginTypes.Inline,
        pluginName: 'EditorJS Inline Code',
        shortcut: 'CTRL+SHIFT+C'
    };
    /**
     * A module that provides the default EditorJS `<p>` block tool.
     * See [the GitHub repo](https://github.com/editor-js/paragraph) for API details
     */
    var PluginInlineCodeModule = /** @class */ (function () {
        function PluginInlineCodeModule() {
        }
        PluginInlineCodeModule = __decorate([
            core.NgModule({
                providers: [
                    {
                        provide: EDITOR_JS_TOOL_INJECTOR,
                        useValue: ɵ0$4,
                        multi: true
                    },
                    {
                        provide: PLUGIN_CONFIG,
                        useValue: ɵ1$4,
                        multi: true
                    }
                ]
            })
        ], PluginInlineCodeModule);
        return PluginInlineCodeModule;
    }());

    var ɵ0$5 = Link, ɵ1$5 = {
        key: 'link',
        type: exports.PluginTypes.Block,
        pluginName: 'EditorJS Link'
    };
    /**
     * A module that provides the default EditorJS `<img>` block tool.
     * See [the GitHub repo](https://github.com/editor-js/image) for API details
     */
    var PluginLinkModule = /** @class */ (function () {
        function PluginLinkModule() {
        }
        PluginLinkModule = __decorate([
            core.NgModule({
                providers: [
                    {
                        provide: EDITOR_JS_TOOL_INJECTOR,
                        useValue: ɵ0$5,
                        multi: true
                    },
                    {
                        provide: PLUGIN_CONFIG,
                        useValue: ɵ1$5,
                        multi: true
                    }
                ]
            })
        ], PluginLinkModule);
        return PluginLinkModule;
    }());

    var ɵ0$6 = List, ɵ1$6 = {
        key: 'list',
        type: exports.PluginTypes.Block,
        pluginName: 'EditorJS List'
    };
    /**
     * A module that provides the default EditorJS `<img>` block tool.
     * See [the GitHub repo](https://github.com/editor-js/image) for API details
     */
    var PluginListModule = /** @class */ (function () {
        function PluginListModule() {
        }
        PluginListModule = __decorate([
            core.NgModule({
                providers: [
                    {
                        provide: EDITOR_JS_TOOL_INJECTOR,
                        useValue: ɵ0$6,
                        multi: true
                    },
                    {
                        provide: PLUGIN_CONFIG,
                        useValue: ɵ1$6,
                        multi: true
                    }
                ]
            })
        ], PluginListModule);
        return PluginListModule;
    }());

    var ɵ0$7 = Marker, ɵ1$7 = {
        key: 'paragraph',
        type: exports.PluginTypes.Inline,
        pluginName: 'EditorJS Marker',
        shortcut: 'CTRL+SHIFT+M'
    };
    /**
     * A module that provides the default EditorJS `<p>` block tool.
     * See [the GitHub repo](https://github.com/editor-js/paragraph) for API details
     */
    var PluginMarkerModule = /** @class */ (function () {
        function PluginMarkerModule() {
        }
        PluginMarkerModule = __decorate([
            core.NgModule({
                providers: [
                    {
                        provide: EDITOR_JS_TOOL_INJECTOR,
                        useValue: ɵ0$7,
                        multi: true
                    },
                    {
                        provide: PLUGIN_CONFIG,
                        useValue: ɵ1$7,
                        multi: true
                    }
                ]
            })
        ], PluginMarkerModule);
        return PluginMarkerModule;
    }());

    var ɵ0$8 = Marker, ɵ1$8 = {
        key: 'paragraph',
        type: exports.PluginTypes.Block,
        pluginName: 'EditorJS Paragraph'
    };
    /**
     * A module that provides the default EditorJS `<p>` block tool.
     * See [the GitHub repo](https://github.com/editor-js/paragraph) for API details
     */
    var PluginParagraphModule = /** @class */ (function () {
        function PluginParagraphModule() {
        }
        PluginParagraphModule = __decorate([
            core.NgModule({
                providers: [
                    {
                        provide: EDITOR_JS_TOOL_INJECTOR,
                        useValue: ɵ0$8,
                        multi: true
                    },
                    {
                        provide: PLUGIN_CONFIG,
                        useValue: ɵ1$8,
                        multi: true
                    }
                ]
            })
        ], PluginParagraphModule);
        return PluginParagraphModule;
    }());

    var ɵ0$9 = Quote, ɵ1$9 = {
        key: 'quote',
        type: exports.PluginTypes.Block,
        pluginName: 'EditorJS Quote Tool',
        inlineToolbar: true
    };
    /**
     * A module that provides the default EditorJS `<p>` block tool.
     * See [the GitHub repo](https://github.com/editor-js/paragraph) for API details
     */
    var PluginQuoteModule = /** @class */ (function () {
        function PluginQuoteModule() {
        }
        PluginQuoteModule = __decorate([
            core.NgModule({
                providers: [
                    {
                        provide: EDITOR_JS_TOOL_INJECTOR,
                        useValue: ɵ0$9,
                        multi: true
                    },
                    {
                        provide: PLUGIN_CONFIG,
                        useValue: ɵ1$9,
                        multi: true
                    }
                ]
            })
        ], PluginQuoteModule);
        return PluginQuoteModule;
    }());

    var ɵ0$a = SimpleImage, ɵ1$a = {
        key: 'simpleimage',
        type: exports.PluginTypes.Block,
        pluginName: 'EditorJS Simple Image'
    };
    /**
     * A module that provides the default EditorJS `<img>` block tool.
     * See [the GitHub repo](https://github.com/editor-js/image) for API details
     */
    var PluginSimpleImageModule = /** @class */ (function () {
        function PluginSimpleImageModule() {
        }
        PluginSimpleImageModule = __decorate([
            core.NgModule({
                providers: [
                    {
                        provide: EDITOR_JS_TOOL_INJECTOR,
                        useValue: ɵ0$a,
                        multi: true
                    },
                    {
                        provide: PLUGIN_CONFIG,
                        useValue: ɵ1$a,
                        multi: true
                    }
                ]
            })
        ], PluginSimpleImageModule);
        return PluginSimpleImageModule;
    }());

    var ɵ0$b = Warning, ɵ1$b = {
        key: 'warning',
        type: exports.PluginTypes.Block,
        pluginName: 'EditorJS Warning Block',
        inlineToolbar: true
    };
    /**
     * A module that provides the default EditorJS `<p>` block tool.
     * See [the GitHub repo](https://github.com/editor-js/paragraph) for API details
     */
    var PluginWarningModule = /** @class */ (function () {
        function PluginWarningModule() {
        }
        PluginWarningModule = __decorate([
            core.NgModule({
                providers: [
                    {
                        provide: EDITOR_JS_TOOL_INJECTOR,
                        useValue: ɵ0$b,
                        multi: true
                    },
                    {
                        provide: PLUGIN_CONFIG,
                        useValue: ɵ1$b,
                        multi: true
                    }
                ]
            })
        ], PluginWarningModule);
        return PluginWarningModule;
    }());

    /**
     * Factory function to create the plugin config map for the plugin service
     * @param pluginConfigs The array of plugin configuration objects passed to this factory
     * @param plugins The array of `EditorJS` plugins that are passed to this factory
     */
    function createPluginConfig(pluginConfigs, plugins) {
        return pluginConfigs.reduce(function (pluginConfig, config, index) {
            var _a;
            return typeof config === 'undefined'
                ? pluginConfig
                : __assign(__assign({}, pluginConfig), (_a = {}, _a[config.key] = __assign(__assign({}, config), { plugin: plugins[index] }), _a));
        }, {});
    }

    /**
     * The `NgxEditorJSPluginService` is provided as a root service for handling {@link https://github.com/editor-js | EditorJS plugins}.
     *
     * Plugins are provided by using {@link https://angular.io/api/core/NgModule | NgModule} to inject the plugin with a
     * {@link ../interfaces/PluginConfig.html | PluginConfig} using providers.
     */
    var NgxEditorJSPluginService = /** @class */ (function () {
        /**
         * @param pluginConfigMap The plugin configuration map injected into the application
         */
        function NgxEditorJSPluginService(pluginConfigMap) {
            this.pluginConfigMap = pluginConfigMap;
        }
        /**
         * Get a map of all plugin configurations
         * @returns The map of plugins injected into this plugin
         */
        NgxEditorJSPluginService.prototype.getPlugins = function () {
            return this.pluginConfigMap;
        };
        /**
         * Get a plugin configuration via it's key
         * @param key The key of the plugin to get
         * @returns The plugin configuration for the passed key
         */
        NgxEditorJSPluginService.prototype.getPlugin = function (key) {
            return this.pluginConfigMap[key];
        };
        /**
         * Get a list of plugins, filtering with an exclude list of plugins
         * @param excludeList
         */
        NgxEditorJSPluginService.prototype.getPluginsWithExclude = function (excludeList) {
            if (excludeList === void 0) { excludeList = []; }
            return Object.entries(this.pluginConfigMap)
                .filter(function (_a) {
                var _b = __read(_a, 1), key = _b[0];
                return !excludeList.includes(key);
            })
                .reduce(function (pluginMap, _a) {
                var _b;
                var _c = __read(_a, 2), key = _c[0], plugin = _c[1];
                return __assign(__assign({}, pluginMap), (_b = {}, _b[key] = plugin, _b));
            }, {});
        };
        /**
         * Get a list of plugins, filtering with an include list of plugins
         * @param includeList
         */
        NgxEditorJSPluginService.prototype.getPluginsWithInclude = function (includeList) {
            if (includeList === void 0) { includeList = []; }
            return Object.entries(this.pluginConfigMap)
                .filter(function (_a) {
                var _b = __read(_a, 1), key = _b[0];
                return includeList.includes(key);
            })
                .reduce(function (pluginMap, _a) {
                var _b;
                var _c = __read(_a, 2), key = _c[0], plugin = _c[1];
                return __assign(__assign({}, pluginMap), (_b = {}, _b[key] = plugin, _b));
            }, {});
        };
        /**
         * Returns a map of {@link https://editorjs.io/api | EditorJS} tools to be initialized by the editor
         * @param excludeTools Optional array of tools to exclude, if not passed all tools
         */
        NgxEditorJSPluginService.prototype.getTools = function (excludeTools) {
            if (excludeTools === void 0) { excludeTools = []; }
            return Object.entries(this.getPluginsWithExclude(excludeTools)).reduce(function (finalTools, _a) {
                var _b;
                var _c = __read(_a, 2), key = _c[0], plugin = _c[1];
                var tool = {
                    class: plugin.plugin
                };
                if (plugin.shortcut)
                    tool.shortcut = plugin.shortcut;
                if (plugin.type === 'inline' || plugin.inlineToolbar)
                    tool.inlineToolbar = true;
                if (plugin.config)
                    tool.config = plugin.config;
                return __assign(__assign({}, finalTools), (_b = {}, _b[key] = tool, _b));
            }, {});
        };
        NgxEditorJSPluginService.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [PluginClasses,] }] }
        ]; };
        NgxEditorJSPluginService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function NgxEditorJSPluginService_Factory() { return new NgxEditorJSPluginService(core["ɵɵinject"](PluginClasses)); }, token: NgxEditorJSPluginService, providedIn: "root" });
        NgxEditorJSPluginService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __param(0, core.Inject(PluginClasses)),
            __metadata("design:paramtypes", [Object])
        ], NgxEditorJSPluginService);
        return NgxEditorJSPluginService;
    }());

    var ɵ0$c = undefined, ɵ1$c = undefined, ɵ2 = createPluginConfig;
    var NgxEditorJSPluginServiceModule = /** @class */ (function () {
        function NgxEditorJSPluginServiceModule() {
        }
        NgxEditorJSPluginServiceModule = __decorate([
            core.NgModule({
                providers: [
                    {
                        provide: PLUGIN_CONFIG,
                        useValue: ɵ0$c,
                        multi: true
                    },
                    {
                        provide: EDITOR_JS_TOOL_INJECTOR,
                        useValue: ɵ1$c,
                        multi: true
                    },
                    {
                        provide: PluginClasses,
                        useFactory: ɵ2,
                        deps: [PLUGIN_CONFIG, EDITOR_JS_TOOL_INJECTOR]
                    },
                    NgxEditorJSPluginService
                ]
            })
        ], NgxEditorJSPluginServiceModule);
        return NgxEditorJSPluginServiceModule;
    }());

    /**
     * The `NgxEditorjsPluginsModule` provides several additional modules
     * that provide a way to easily plug in block and inline tools for EditorJS.
     *
     * Importing `NgxEditorjsPluginsModule` will include all modules, while it
     * is also possible to import each individual module as required.
     */
    var NgxEditorjsPluginsModule = /** @class */ (function () {
        function NgxEditorjsPluginsModule() {
        }
        NgxEditorjsPluginsModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    NgxEditorJSPluginServiceModule,
                    PluginCodeModule,
                    PluginHeaderModule,
                    PluginImageModule,
                    PluginLinkModule,
                    PluginListModule,
                    PluginMarkerModule,
                    PluginParagraphModule,
                    PluginSimpleImageModule,
                    PluginInlineCodeModule,
                    PluginWarningModule,
                    PluginQuoteModule,
                    PluginEmbedModule
                ],
                exports: [
                    NgxEditorJSPluginServiceModule,
                    PluginCodeModule,
                    PluginHeaderModule,
                    PluginImageModule,
                    PluginLinkModule,
                    PluginListModule,
                    PluginMarkerModule,
                    PluginParagraphModule,
                    PluginSimpleImageModule,
                    PluginInlineCodeModule,
                    PluginWarningModule,
                    PluginQuoteModule,
                    PluginEmbedModule
                ]
            })
        ], NgxEditorjsPluginsModule);
        return NgxEditorjsPluginsModule;
    }());

    exports.EDITOR_JS_TOOL_INJECTOR = EDITOR_JS_TOOL_INJECTOR;
    exports.NgxEditorJSPluginService = NgxEditorJSPluginService;
    exports.NgxEditorJSPluginServiceModule = NgxEditorJSPluginServiceModule;
    exports.NgxEditorjsPluginsModule = NgxEditorjsPluginsModule;
    exports.PLUGIN_CONFIG = PLUGIN_CONFIG;
    exports.PluginClasses = PluginClasses;
    exports.PluginCodeModule = PluginCodeModule;
    exports.PluginEmbedModule = PluginEmbedModule;
    exports.PluginHeaderModule = PluginHeaderModule;
    exports.PluginImageModule = PluginImageModule;
    exports.PluginInlineCodeModule = PluginInlineCodeModule;
    exports.PluginLinkModule = PluginLinkModule;
    exports.PluginListModule = PluginListModule;
    exports.PluginMarkerModule = PluginMarkerModule;
    exports.PluginParagraphModule = PluginParagraphModule;
    exports.PluginQuoteModule = PluginQuoteModule;
    exports.PluginSimpleImageModule = PluginSimpleImageModule;
    exports.PluginWarningModule = PluginWarningModule;
    exports.createPluginConfig = createPluginConfig;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=tinynodes-ngx-editorjs-plugins.umd.js.map
